 *=$6000
 !to "HL.bin", plain	; set output file and format
 !cpu 6502		; set processor type

;;	jmp circ
;;;test
;;	lda _A
;;	sta 0
;;	lda _A+1
;;	sta 1
;;
;;	lda _B
;;	sta 2
;;	lda _B+1
;;	sta 3
;;	jsr cmp16;CY=1 if A>B (0.1)>(2.3)
;;	bcc b_g_a
;;	LDY	#>AGB
;;	LDA	#<AGB
;;	jmp prn
;;b_g_a:
;;	LDY	#>BGA
;;	LDA	#<BGA
;;prn:
;;	JSR	$DB3A;STROUT
;;stub:	jmp stub
;;AGB:!pet 13,"A>B",0
;;BGA:!pet 13,"B>A",0
;;_A: !word 0
;;_B: !word -1

circ:
	jsr $F3E2 ; HGR
	lda $C052
;color
	ldx #3
	jsr $F6F0;SETHCOL
;plot
;	lda #$60;Y
;	LDX #70
;	LDY #0
;	jsr $F457;HPLOT
;	rts

;void plotCircle(int xm, int ym, int r)
;{
;   int x = -r, y = 0, err = 2-2*r; /* II. Quadrant */ 
	lda #0
	sta _Y
	sta _Y+1

;-r
	sec
	sbc _R
	sta _X

	lda #0
	sbc _R+1
	sta _X+1

;1-r
	lda #1
	sec
	sbc _R
	sta _ERR
	lda #0
	sbc _R+1
	sta _ERR+1
;*2
	lda _ERR
	clc
	adc _ERR
	sta _ERR
	lda _ERR+1
	adc _ERR+1
	sta _ERR+1
;	ASL _ERR
;	ROL _ERR+1

dolp:
;   do {
;      setPixel(xm-x, ym+y); /*   I. Quadrant */

;	LDX #70 ;X = low byte X-coordinate
	lda _XM
	sec
	sbc _X
	tax
;	LDY #0 ;Y = hi byte X-coordinate
	lda _XM+1
	sbc _X+1
	tay
;	lda #$60;Y
	lda _YM
	clc
	adc _Y
	jsr $F457;HPLOT

;      setPixel(xm-y, ym-x); /*  II. Quadrant */
	lda _XM
	sec
	sbc _Y
	tax
	lda _XM+1
	sbc _Y+1
	tay
	lda _YM
	sec
	sbc _X
	jsr $F457;HPLOT

;      setPixel(xm+x, ym-y); /* III. Quadrant */
	lda _XM
	clc
	adc _X
	tax
	lda _XM+1
	adc _X+1
	tay
	lda _YM
	sec
	sbc _Y
	jsr $F457;HPLOT
	
;      setPixel(xm+y, ym+x); /*  IV. Quadrant */
	lda _XM
	clc
	adc _Y
	tax
	lda _XM+1
	clc
	adc _Y+1
	tay
	lda _YM
	clc
	adc _X
	jsr $F457;HPLOT

;      r = err
	lda _ERR
	sta _R
	lda _ERR+1
	sta _R+1

;      if (r <= y) err += ++y*2+1;           /* e_xy+e_y < 0 */
;?r<y 60A3
	lda _R
	cmp _Y
	bne contif
	lda _R+1
	cmp _Y+1
	beq yes1
contif:
	lda _R ;60B6
	sta 2
	lda _R+1
	sta 3

	lda _Y
	sta 0
	lda _Y+1
	sta 1

	jsr cmp16 ; CY=1 if (0.1)>(2.3),y>r
	bcs yes1 ; 60CA
	jmp eif1
;err += ++y*2+1  
yes1:
	inc _Y
	bne noyp
	inc _Y+1
noyp:
	jsr incerr

	lda _Y
	ldy _Y+1
	jsr erradd16
	jsr erradd16
	
;	jsr erraddy
;	jsr erraddy
eif1:
;      if (r > x || err > y) err += ++x*2+1; /* e_xy+e_x > 0 or no 2nd y-step */

	lda _R ; 60E0
	sta 0
	lda _R+1
	sta 1

	lda _X
	sta 2
	lda _X+1
	sta 3

	jsr cmp16 ; CY=1 if (0.1)>(2.3),r>x
	bcs yes23
yes21:
	lda _ERR
	sta 0
	lda _ERR+1
	sta 1
	lda _Y
	sta 2
	lda _Y+1
	sta 3

;610D
	jsr cmp16; CY=1 if (0.1)>(2.3),err>y
	bcs yes22
;	inx
	jmp l_while
yes22:
;	cpx #0
;	beq l_while
yes23:
;err += ++x*2+1;
	inc _X
	bne noxp
	inc _X+1
noxp:
	jsr incerr

	lda _X
	ldy _X+1
	jsr erradd16
	jsr erradd16

;	jsr erraddx
;	jsr erraddx
l_while:
;   } while (x < 0);
	lda _X
	bpl ex_lp
	jmp dolp
ex_lp:
	rts

erradd16: ;_ERR+n16
	pha
	clc
	adc _ERR
	sta _ERR
	tya
	adc _ERR+1
	sta _ERR+1
	pla
	rts

erraddx:
	lda _X
	clc
	adc _ERR
	sta _ERR

	lda _X+1
	adc _ERR+1
	sta _ERR+1
	rts

erraddy:
	lda _Y
	clc
	adc _ERR
	sta _ERR

	lda _Y+1
	adc _ERR+1
	sta _ERR+1
	rts
incerr:
	inc _ERR
	bne noprh
	inc _ERR+1
noprh:
	rts
;http://www.6502.org/tutorials/compare_beyond.html
;Example 6.3: a 16-bit signed comparison that branches to LABEL4 if NUM1 < NUM2 (similar to Example 4.1.1 in Section 4.1)
cmp16:
		   SEC
           LDA 1;NUM1H  ; compare high bytes
           SBC 3;NUM2H
           BVC LABEL1 ; the equality comparison is in the Z flag here
           EOR #$80   ; the Z flag is affected here
LABEL1 BMI LABEL4 ; if NUM1H < NUM2H then NUM1 < NUM2
           BVC LABEL2 ; the Z flag was affected only if V is 1
           EOR #$80   ; restore the Z flag to the value it had after SBC NUM2H
LABEL2 BNE LABEL3 ; if NUM1H <> NUM2H then NUM1 > NUM2 (so NUM1 >= NUM2)
           LDA 0;NUM1L  ; compare low bytes
           SBC 2;NUM2L
           BCC LABEL4 ; if NUM1L < NUM2L then NUM1 < NUM2
LABEL3
	sec
	rts
LABEL4
	clc
	rts

;;	lda 1 ; Ah
;;	bpl aisp
;;	jmp aisn
;;aisp:
;;	lda 3 ; Bh
;;	bpl bisp
;;	jmp abn
;;bisp:
;;;A>0,B>0
;;;B-A, CY=1
;;	lda 2 ; Bl
;;	sec
;;	sbc 0 ; Al
;;	lda 3 ; Bh
;;	sbc 1 ; Ah
;;	bpl resab
;;	sec
;;	rts
;;resab:
;;	clc
;;	rts
;;abn:
;;;A>0,B<0
;;	sec ;CY=1 if A>B
;;	rts
;;aisn:
;;;A<0,B>0
;;	lda 3 ; Bh
;;	bmi bisn
;;	clc
;;	rts
;;;A<0,B<0
;;bisn:
;;;A=-A
;;	lda #0
;;	sec
;;	sbc 0
;;	sta 0
;;	lda #0
;;	sbc 1
;;	sta 1
;;;B=-B
;;	lda #0
;;	sec
;;	sbc 2
;;	sta 2
;;	lda #0
;;	sbc 3
;;	sta 3
;;	
;;	lda 2 ; Bl
;;	sec
;;	sbc 0 ; Al
;;	lda 3 ; Bh
;;	sbc 1 ; Ah
;;	bmi resba
;;	sec
;;	rts
;;resba:
;;	clc
;;	rts
;		   SEC
;           LDA 1;NUM1H  ; compare high bytes
;           SBC 3;NUM2H
;           BVC LABEL1 ; the equality comparison is in the Z flag here
;           EOR #$80   ; the Z flag is affected here
;LABEL1 BMI LABEL4 ; if NUM1H < NUM2H then NUM1 < NUM2
;           BVC LABEL2 ; the Z flag was affected only if V is 1
;           EOR #$80   ; restore the Z flag to the value it had after SBC NUM2H
;LABEL2 BNE LABEL3 ; if NUM1H <> NUM2H then NUM1 > NUM2 (so NUM1 >= NUM2)
;           LDA 0;NUM1L  ; compare low bytes
;           SBC 2;NUM2L
;           BCC LABEL4 ; if NUM1L < NUM2L then NUM1 < NUM2
;LABEL3
;	clc
;	rts
;LABEL4
;	sec
;	rts
_X:	!word 0
_Y:	!word 0
_R:	!word 70
_ERR: !word 0
_XM:!word 140
_YM:!word 96
